
import bpy


########################################################################
# mecobi
# random_extrude.py
# Script to subdivide an object, select random faces, extrude and then..
# sometimes..interesting structures appear...
########################################################################


bpy.ops.object.mode_set(mode='OBJECT')

bpy.ops.object.delete(use_global=False)


#########################
# add plane or any object
#########################

bpy.ops.mesh.primitive_plane_add(radius=5)


###########
# edit mode
###########


bpy.ops.object.mode_set(mode="EDIT")


#####################
# face selection mode
#####################


bpy.ops.mesh.select_mode(type="FACE")

############
# fix height
############

extrudeHeight = 0.5

for i in range(3):


    randomPercent= 15


    #######################
    # random face selection
    #######################

    bpy.ops.mesh.select_random(percent=randomPercent,seed=1)


    ###################################
    # subdivide random face three times
    ###################################

    for i in range(3):
        bpy.ops.mesh.subdivide(smoothness=0)

    ####################
    # deselect all faces
    ####################

    bpy.ops.mesh.select_all(action = 'DESELECT')


    #######################
    # random face selection
    #######################

    bpy.ops.mesh.select_random(percent=randomPercent,seed=1)


    ########################
    # extrude selected faces
    ########################


    bpy.ops.mesh.extrude_faces_move(TRANSFORM_OT_shrink_fatten={"value":-extrudeHeight})


    ####################
    # deselect all faces
    ####################

    bpy.ops.mesh.select_all(action = 'DESELECT')

    extrudeHeight += extrudeHeight


bpy.ops.object.mode_set(mode='OBJECT')
